#ifndef SPICE3_LASER_API_
#define SPICE3_LASER_API_

#include "rlTypes.h"

RL_C_API rlResult rlLaserInitConfig( rlLaserConfig* config );
RL_C_API rlResult rlLaserToStringConfig( const rlLaserConfig* config, char* buffer, uint32_t bufferSize, uint32_t* stringLength );
RL_C_API rlResult rlLaserLoadConfig( rlHandle handle );
RL_C_API rlResult rlLaserStoreConfig( rlHandle handle );
RL_C_API rlResult rlLaserGetConfig( rlHandle handle, rlLaserConfig* config );
RL_C_API rlResult rlLaserSetConfig( rlHandle handle, const rlLaserConfig* config );

RL_C_API rlResult rlLaserCreatePowerCalibration( rlHandle handle, rlPowerChannels powerTargetChannel );
RL_C_API rlResult rlLaserLoadPowerCalibration( rlHandle handle, rlPowerChannels powerTargetChannel );
RL_C_API rlResult rlLaserStorePowerCalibration( rlHandle handle, rlPowerChannels powerTargetChannel );
RL_C_API rlResult rlLaserGetPowerCalibration( rlHandle handle, rlPowerChannels powerTargetChannel, uint32_t* buffer, int32_t bufferSize, int32_t* calibrationValuesCount );
RL_C_API rlResult rlLaserSetPowerCalibration( rlHandle handle, rlPowerChannels powerTargetChannel, const uint32_t* calibrationValues, int32_t calibrationValuesLength );
RL_C_API rlResult rlLaserPowerCalibrationSet( rlHandle handle, rlPowerChannels powerTargetChannel, const char* localFileName );
RL_C_API rlResult rlLaserPowerCalibrationGet( rlHandle handle, rlPowerChannels powerTargetChannel, const char* localFileName );

RL_C_API rlResult rlLaserIsPilotEnabled( rlHandle handle, bool* enabled );
RL_C_API rlResult rlLaserEnablePilot( rlHandle handle, bool enable );

RL_C_API rlResult rlLaserIsLaserArmed( rlHandle handle, bool* armed );
RL_C_API rlResult rlLaserArmLaser( rlHandle handle, bool arm );

RL_C_API rlResult rlLaserReadLaserStatus( rlHandle handle, rlLaserStatus* laserStatus );

RL_C_API rlResult rlLaserGetPowerScale( rlHandle handle, rlPowerChannels powerTargetChannel, double* out );
RL_C_API rlResult rlLaserSetPowerScale( rlHandle handle, rlPowerChannels powerTargetChannel, double scale );

RL_C_API rlResult rlLaserLaserOn( rlHandle handle );
RL_C_API rlResult rlLaserLaserOff( rlHandle handle );

#endif // SPICE3_LASER_API_
